#! /bin/sh

# Note that this tests the INSTALLED shared libs, not the ones in the
# tree. 8-(

# Need job control.
set -m

# Test the various options for the limit match.
insmod ../packet-filter/extentions/ipt_limit.o || exit 1

../packet-filter/userspace/iptables -A FORWARD -m limit --limit 100/sec || exit 1

if [ "`../packet-filter/userspace/iptables -L FORWARD | grep '^ '`" != "           all  --  anywhere              anywhere            limit: avg 100/sec burst 5 " ]
then
    echo Unexpected ouptut from \`-m limit --limit 100/sec\'
    ../packet-filter/userspace/iptables -L FORWARD
    exit 1
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -A FORWARD -m limit --limit 100 || exit 1

if [ "`../packet-filter/userspace/iptables -L FORWARD | grep '^ '`" != "           all  --  anywhere              anywhere            limit: avg 100/sec burst 5 " ]
then
    echo Unexpected ouptut from \`-m limit --limit 100\'
    ../packet-filter/userspace/iptables -L FORWARD
    exit 1
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -A FORWARD -m limit --limit 100/min --limit-burst 10 || exit 1

if [ "`../packet-filter/userspace/iptables -L FORWARD | grep '^ '`" != "           all  --  anywhere              anywhere            limit: avg 100/min burst 10 " ]
then
    echo Unexpected ouptut from \`-m limit --limit 100/min --limit-burst 10/m\'
    ../packet-filter/userspace/iptables -L FORWARD
    exit 1
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -A FORWARD -m limit --limit 100/hour --limit-burst 1 || exit 1

if [ "`../packet-filter/userspace/iptables -L FORWARD | grep '^ '`" != "           all  --  anywhere              anywhere            limit: avg 100/hour burst 1 " ]
then
    echo Unexpected ouptut from \`--limit 100/hour --limit-burst 1\'
    ../packet-filter/userspace/iptables -L FORWARD
    exit 1
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
../packet-filter/userspace/iptables -A FORWARD -m limit --limit 1/day --limit-burst 2 || exit 1

if [ "`../packet-filter/userspace/iptables -L FORWARD | grep '^ '`" != "           all  --  anywhere              anywhere            limit: avg 1/day burst 2 " ]
then
    echo Unexpected ouptut from \`--limit 1/day --limit-burst 2\'
    ../packet-filter/userspace/iptables -L FORWARD
    exit 1
fi

../packet-filter/userspace/iptables -F FORWARD || exit 1
rmmod ipt_limit || exit 1

exit 0
